<?php

namespace Lc\SovBundle\Container\Ticket;

use Lc\SovBundle\Factory\Ticket\TicketMessageFactory;
use Lc\SovBundle\Repository\Ticket\TicketMessageRepositoryQuery;
use Lc\SovBundle\Repository\Ticket\TicketMessageStore;

class TicketMessageContainer
{
    protected TicketMessageFactory $factory;
    protected TicketMessageRepositoryQuery $repositoryQuery;
    protected TicketMessageStore $store;

    public function __construct(
            TicketMessageFactory $factory,
            TicketMessageRepositoryQuery $repositoryQuery,
            TicketMessageStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): TicketMessageFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): TicketMessageRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): TicketMessageStore
    {
        return $this->store;
    }
}
