<?php

namespace Lc\SovBundle\Controller\Setting;

use Doctrine\ORM\EntityManagerInterface;
use Lc\SovBundle\Container\Setting\SiteSettingContainer;
use Lc\SovBundle\Container\Site\SiteContainer;
use Lc\SovBundle\Definition\SiteSettingDefinitionInterface;
use Lc\SovBundle\Form\Setting\SiteSettingsFormType;
use Lc\SovBundle\Repository\Setting\SiteSettingRepository;
use Lc\SovBundle\Repository\Site\SiteRepository;
use Lc\SovBundle\Translation\TranslatorAdmin;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;

class SettingAdminController extends AbstractController
{

    /**
     * @Route("/admin/setting/site", name="sov_admin_setting_site")
     */
    public function manageGlobal(Request $request, EntityManagerInterface $entityManager)
    {

        $site = $this->get(SiteContainer::class)->getStore()->getOneByDevAlias('default') ;
        $form = $this->createForm(SiteSettingsFormType::class, $site);

        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {

            $entityManager->update($site);
            $entityManager->flush();

            $this->addFlash('success', $this->get(TranslatorAdmin::class)->transFlashMessage('settings_saved'));
        }

        return $this->render(
                '@LcSov/admin/setting/edit_site.html.twig' ,
                [
                        'setting_definition' => $this->get(SiteSettingContainer::class)->getDefinition(),
                        'form' => $form->createView()
                ]
        );
    }

}